import os
from ..emitter import Emitter


class FileEmitter(Emitter):
    """Emitter representation for find_files.
    """

    # Public

    def __init__(self, value, *, basedir, filepath, **context):
        self.__basedir = basedir
        self.__filepath = filepath
        super().__init__(value, **context)

    @property
    def basedir(self):
        return self.__basedir

    @property
    def filename(self):
        return os.path.basename(self.filepath)

    @property
    def filepath(self):
        return self.__filepath