import re
import fnmatch
from ..constraint import PatternConstraint
from ..helpers import RegexType


class FilenameConstraint(PatternConstraint):

    # Public

    def extend(self, name, value):
        if name == 'filename':
            self._include.append(value)
        if name == 'notfilename':
            self._exclude.append(value)

    # Protected

    def _match(self, emitter, pattern):
        if isinstance(pattern, RegexType):
            if re.search(pattern, emitter.filename):
                return True
        else:
            if fnmatch.fnmatch(emitter.filename, pattern):
                return True
        return False
