import os
from ..constraint import Constraint


class MaxdepthConstraint(Constraint):

    # Public

    def __init__(self):
        self.__maxdepth = None

    def __bool__(self):
        return (self.__maxdepth is not None)

    def __call__(self, emitter):
        if self.__maxdepth is not None:
            depth = emitter.filepath.count(os.path.sep) + 1
            if depth > self.__maxdepth:
                emitter.skip()
                emitter.stop()

    def extend(self, name, value):
        if name == 'maxdepth':
            self.__maxdepth = value
