from ..files import FileEmitter


class ObjectEmitter(FileEmitter):
    """Emitter representation for find_objects.
    """

    # Public

    def __init__(self, value, *,
                 basedir, filepath,
                 module, objname, objself, **context):
        self.__module = module
        self.__objname = objname
        self.__objself = objself
        super().__init__(value, basedir=basedir, filepath=filepath, **context)

    @property
    def module(self):
        return self.__module

    @property
    def objname(self):
        return self.__objname

    @property
    def objself(self):
        return self.__objself

    @property
    def objtype(self):
        return type(self.objself)
