import unittest
from importlib import import_module
component = import_module('run_find.objects.emitter')


class ObjectEmitterTest(unittest.TestCase):

    # Actions

    def setUp(self):
        self.emitter = component.ObjectEmitter(
            'value', basedir='basedir', filepath='dir/file',
            module='module', objname='objname', objself='objself')

    # Tests

    def test_module(self):
        self.assertEqual(self.emitter.module, 'module')

    def test_objname(self):
        self.assertEqual(self.emitter.objname, 'objname')

    def test_objself(self):
        self.assertEqual(self.emitter.objself, 'objself')

    def test_objtype(self):
        self.assertEqual(self.emitter.objtype, str)
